aboutsummaryrefslogtreecommitdiff
path: root/tools/test/stress2/misc/snap5.sh
diff options
context:
space:
mode:
authorPeter Holm <pho@FreeBSD.org>2021-03-03 12:56:56 +0000
committerPeter Holm <pho@FreeBSD.org>2021-03-03 14:11:40 +0000
commit8a272653d9fbd9fc37691c9aad6a05089b4ecb4d (patch)
tree2463ed22a342700cb7ba2b05c3d5370f75090899 /tools/test/stress2/misc/snap5.sh
parent3adf72a36b9b151eef57e3d83f71a3a9fbacb78d (diff)
downloadsrc-8a272653d9fbd9fc37691c9aad6a05089b4ecb4d.tar.gz
src-8a272653d9fbd9fc37691c9aad6a05089b4ecb4d.zip
Diffstat (limited to 'tools/test/stress2/misc/snap5.sh')
-rwxr-xr-xtools/test/stress2/misc/snap5.sh55
1 files changed, 55 insertions, 0 deletions
diff --git a/tools/test/stress2/misc/snap5.sh b/tools/test/stress2/misc/snap5.sh
new file mode 100755
index 000000000000..7b446c4acbcd
--- /dev/null
+++ b/tools/test/stress2/misc/snap5.sh
@@ -0,0 +1,55 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2008, 2011 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+mount | grep -q "on /tmp (ufs," || exit 0
+mnt2=${mntpoint}2
+[ ! -d $mnt2 ] && mkdir $mnt2
+mount | grep -q "/dev/md$mdstart on $mnt2" && umount $mnt2
+mdconfig -l | grep -q md$mdstart && mdconfig -d -u $mdstart
+rm -f /tmp/.snap/stress2
+trap "rm -f /tmp/.snap/stress2" 0
+
+start=`date '+%s'`
+while [ `date '+%s'` -lt $((start + 1200)) ]; do
+ date '+%T'
+ mksnap_ffs /tmp /tmp/.snap/stress2
+ mdconfig -a -t vnode -f /tmp/.snap/stress2 -u $mdstart -o readonly
+ mount -o ro /dev/md$mdstart $mnt2
+
+ ls -l $mnt2 > /dev/null
+ r=`head -c4 /dev/random | od -N2 -tu4 | sed -ne '1s/ *$//;1s/.* //p'`
+ sleep $(( r % 120 ))
+
+ umount $mnt2
+ mdconfig -d -u $mdstart
+ rm -f /tmp/.snap/stress2
+done